program phasehex2dec;

{$APPTYPE CONSOLE}

uses
  SysUtils, math;

var fi:Textfile;


var vd:array[0..15] of integer;
    p:array[0..7] of single;
    pl:array[0..7] of single;
    act:array[0..7] of boolean;
    psum:array[0..7] of extended;
    i,k,j,n:integer;
    s:string;
    dp,pp:single;
begin
  decimalseparator:='.';
  for i:=0 to 7 do pl[i]:=0.0;
  for i:=0 to 7 do psum[i]:=0.0;

  assignfile(fi,paramstr(1));
  reset(fi);
  i:=0;
  while not eof(fi) do begin
    readln(fi,s);
    if length(s)<>64 then continue;
    j:=1;
    k:=1;
    for n:=0 to 15 do begin
      vd[n]:=strtoint('$'+copy(s,1+n*4,4));
      if (vd[n] and $8000)<>0 then vd[n]:=-($10000-vd[n]);
    end;

    for n:=0 to 7 do begin
      if (vd[n*2+1]<>0) or (vd[n*2]<>0) then begin
        p[n]:=ArcTan2(vd[n*2+1],vd[n*2]);
        act[n]:=true;
      end else begin
        p[n]:=0;
        act[n]:=false;
      end;
    end;
    for n:=0 to 7 do begin //phase relative to channel 7
      pp:=(p[7]-p[n])*15.915494; //2pi->100ns
      if pp>100 then pp:=pp-100.0
      else
      if pp<0 then pp:=pp+100.0;
//      p[n]:=pp;
      dp:=pp-pl[n];
      pl[n]:=pp;
      while dp>50.0 do dp:=dp-100.0;
      while dp<-50.0 do dp:=dp+100.0;
      //dp +/- 50ns
      psum[n]:=psum[n]+dp;
      if not act[n] then begin psum[n]:=0; p[n]:=0; end;
    end;

{    s:=inttostr(i)+' '+floattostrf(p[0],fffixed,20,4)+' '+
                       floattostrf(p[1],fffixed,20,4)+' '+
                       floattostrf(p[2],fffixed,20,4)+' '+
                       floattostrf(p[3],fffixed,20,4)+' '+
                       floattostrf(p[4],fffixed,20,4)+' '+
                       floattostrf(p[5],fffixed,20,4)+' '+
                       floattostrf(p[6],fffixed,20,4);
 }
    s:=inttostr(i)+' '+floattostrf(psum[0],fffixed,20,2)+' '+
                       floattostrf(psum[1],fffixed,20,2)+' '+
                       floattostrf(psum[2],fffixed,20,2)+' '+
                       floattostrf(psum[3],fffixed,20,2)+' '+
                       floattostrf(psum[4],fffixed,20,2)+' '+
                       floattostrf(psum[5],fffixed,20,2)+' '+
                       floattostrf(psum[6],fffixed,20,2)+' '+
                       floattostrf(psum[7],fffixed,20,2)+' '+

                       floattostrf(p[0]*15.915494,fffixed,20,2)+' '+
                       floattostrf(p[1]*15.915494,fffixed,20,2)+' '+
                       floattostrf(p[2]*15.915494,fffixed,20,2)+' '+
                       floattostrf(p[3]*15.915494,fffixed,20,2)+' '+
                       floattostrf(p[4]*15.915494,fffixed,20,2)+' '+
                       floattostrf(p[5]*15.915494,fffixed,20,2)+' '+
                       floattostrf(p[6]*15.915494,fffixed,20,2)+' '+
                       floattostrf(p[7]*15.915494,fffixed,20,2)+' ';




    writeln(s);
   // readln;

    inc(i);
  end;
  closefile(fi);;

//  readln;

  { TODO -oUser -cConsole Main : Insert code here }
end.
